"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _validatorjs = _interopRequireDefault(require("validatorjs"));

var _immutabilityHelper = _interopRequireDefault(require("immutability-helper"));

var _getValue = _interopRequireDefault(require("./utils/get-value"));

var _getFieldRules = _interopRequireDefault(require("./utils/get-field-rules"));

var _getFieldMessages = _interopRequireDefault(require("./utils/get-field-messages"));

var _parseCallbackRules = _interopRequireDefault(require("./utils/parse-callback-rules"));

var _unflattenObject = require("./utils/unflatten-object");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var Form = function Form(WrappedComponent) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$rules = _ref.rules,
      rules = _ref$rules === void 0 ? {} : _ref$rules,
      _ref$messages = _ref.messages,
      messages = _ref$messages === void 0 ? {} : _ref$messages,
      _ref$defaultValues = _ref.defaultValues,
      defaultValues = _ref$defaultValues === void 0 ? {} : _ref$defaultValues;

  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(_class, _React$Component);

      function _class(props) {
        var _this;

        _classCallCheck(this, _class);

        _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));
        _this.state = {
          inputs: defaultValues,
          errors: {},
          submitting: false,
          submitted: false
        };
        _this.validate = _this.validate.bind(_assertThisInitialized(_this));
        _this.error = _this.error.bind(_assertThisInitialized(_this));
        _this.errors = _this.errors.bind(_assertThisInitialized(_this));
        _this.hasError = _this.hasError.bind(_assertThisInitialized(_this));
        _this.value = _this.value.bind(_assertThisInitialized(_this));
        _this.setValue = _this.setValue.bind(_assertThisInitialized(_this));
        _this.addValue = _this.addValue.bind(_assertThisInitialized(_this));
        _this.removeValue = _this.removeValue.bind(_assertThisInitialized(_this));
        _this.values = _this.values.bind(_assertThisInitialized(_this));
        _this.setValues = _this.setValues.bind(_assertThisInitialized(_this));
        _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
        _this.onBlur = _this.onBlur.bind(_assertThisInitialized(_this));
        _this.reset = _this.reset.bind(_assertThisInitialized(_this));
        return _this;
      }

      _createClass(_class, [{
        key: "render",
        value: function render() {
          var rest = _objectWithoutProperties(this.props, []);

          return _react.default.createElement(WrappedComponent, _extends({}, rest, {
            hasError: this.hasError,
            onChange: this.onChange,
            onBlur: this.onBlur,
            error: this.error,
            value: this.value,
            values: this.values,
            setValue: this.setValue,
            setValues: this.setValues,
            validate: this.validate,
            addValue: this.addValue,
            errors: this.errors,
            removeValue: this.removeValue,
            reset: this.reset,
            submitting: this.state.submitting,
            submitted: this.state.submitted
          }));
        }
      }, {
        key: "onChange",
        value: function onChange(el) {
          var value;

          switch (el.target.type) {
            case 'select-multiple':
              value = _toConsumableArray(el.target.selectedOptions).map(function (option) {
                return option.value;
              });
              break;

            case 'checkbox':
              value = el.target.checked;
              break;

            default:
              value = el.target.value;
          }

          this.setValue(el.target.name, value);
        }
      }, {
        key: "onBlur",
        value: function onBlur(el) {
          var _this2 = this;

          var fieldRules = (0, _getFieldRules.default)(el.target.name, (0, _parseCallbackRules.default)(rules, [this.props]));
          var fieldMessages = (0, _getFieldMessages.default)(el.target.name, messages);
          var validation = new _validatorjs.default(this.state.inputs, fieldRules, fieldMessages);
          return new Promise(function (accept, reject) {
            validation.fails(function () {
              _this2.setState({
                errors: _extends({}, _this2.state.errors, validation.errors.errors),
                submitting: false,
                submitted: true
              });

              reject();
            });
            validation.passes(function () {
              _this2.setState({
                errors: {},
                submitting: false,
                submitted: true
              });

              accept();
            });
          });
        }
      }, {
        key: "addValue",
        value: function addValue(name, value) {
          this.setState({
            inputs: (0, _immutabilityHelper.default)(this.state.inputs, (0, _unflattenObject.unflattenArrayStateUpdate)(this.state.inputs, name, value))
          });
        }
      }, {
        key: "removeValue",
        value: function removeValue(name) {
          var _this3 = this;

          /**
           * While removing value from an array we need to remove the related errors to that index too
           * @type {*}
           */
          var errorsName = name.split('.');
          var index = parseInt(errorsName.pop(), 10);
          errorsName = errorsName.join('.') + '.';
          var errors = Object.keys(this.state.errors).reduce(function (acc, item) {
            if (item.startsWith(errorsName)) {
              var remainingName = item.substr(errorsName.length, item.length).split('.');
              /* istanbul ignore else */

              if (item.startsWith(name)) {
                return acc;
              }

              var fieldIndex = parseInt(remainingName.shift(), 10);
              /* istanbul ignore else */

              if (fieldIndex > index) {
                fieldIndex--;
              }

              acc["".concat(errorsName).concat(fieldIndex, ".").concat(remainingName.join('.'))] = _this3.state.errors[item];
            } else {
              acc[item] = _this3.state.errors[item];
            }

            return acc;
          }, {});
          this.setState({
            inputs: (0, _immutabilityHelper.default)(this.state.inputs, (0, _unflattenObject.unflattenRemoveArrayStateUpdate)(name)),
            errors: errors
          });
        }
      }, {
        key: "validate",
        value: function validate() {
          var _this4 = this;

          var validation = new _validatorjs.default(this.state.inputs, (0, _parseCallbackRules.default)(rules, [this.props]), messages);
          this.setState({
            submitting: true,
            submitted: false
          });
          return new Promise(function (accept, reject) {
            validation.fails(function () {
              _this4.setState({
                errors: validation.errors.errors,
                submitting: false,
                submitted: true
              });

              reject();
            });
            validation.passes(function () {
              _this4.setState({
                errors: {},
                submitting: false,
                submitted: true
              });

              accept();
            });
          });
        }
      }, {
        key: "error",
        value: function error(name) {
          var classNameOrPlain = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

          if (this.hasError(name)) {
            var error = this.state.errors[name];

            if (classNameOrPlain === true) {
              return error[0];
            }

            return _react.default.createElement("span", {
              className: classNameOrPlain !== false ? classNameOrPlain : ""
            }, error);
          }

          return null;
        }
      }, {
        key: "errors",
        value: function errors() {
          return this.state.errors;
        }
      }, {
        key: "hasError",
        value: function hasError(name) {
          var returnStringOnInvalid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
          var returnStringOnValid = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
          var hasError = typeof this.state.errors[name] !== "undefined";

          if (hasError && returnStringOnInvalid !== false) {
            return returnStringOnInvalid;
          } else if (hasError === false && returnStringOnValid) {
            return returnStringOnValid;
          }

          return hasError;
        }
      }, {
        key: "value",
        value: function value(name) {
          var defaultValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
          return (0, _getValue.default)(this.state.inputs, name, defaultValue);
        }
      }, {
        key: "values",
        value: function values() {
          return this.state.inputs;
        }
      }, {
        key: "setValues",
        value: function setValues(inputs) {
          this.setState({
            inputs: inputs
          });
        }
      }, {
        key: "reset",
        value: function reset() {
          this.setState({
            inputs: {},
            errors: {},
            submitted: false,
            submitting: false
          });
        }
      }, {
        key: "setValue",
        value: function setValue(name, value) {
          this.setState({
            inputs: (0, _immutabilityHelper.default)(this.state.inputs, (0, _unflattenObject.unflatten)("".concat(name, ".$set"), value))
          });
        }
      }]);

      return _class;
    }(_react.default.Component)
  );
};

var _default = Form;
exports.default = _default;